<?php
include_once "example.php";
include_once "functions.php";

add_action('admin_init', 'ngg_geo_options_init' );
add_action('admin_menu', 'ngg_geo_add_page', 99);

// init plugin options
function ngg_geo_options_init(){
	register_setting( 'plugin_ngg_geo', 'plugin_ngg_geo_options', 'ngg_geo_options_admin' );
}

// add menu page
function ngg_geo_add_page() {
	add_submenu_page('nextgen-gallery', __('Maps', 'nextgen-gallery-geo'), __('Maps', 'nextgen-gallery-geo'), 'manage_options', __FILE__, 'ngg_geo_options_page');
}




// create the options page
function ngg_geo_options_page() {
	
	// settings saved?  
	if( isset($_GET['settings-updated']) ) {echo '<div id="message" class="updated"><p><strong> '.__('Settings saved.').' </strong></p></div>';} ?>

    <div class="wrap">
    <h2>NextGEN Gallery Geo</h2>
    <br />
    <? printf(__('This plugin is a add-on for the %1$s plugin, and does only work with this plugin.', 'nextgen-gallery-geo'), '<a href="http://wordpress.org/extend/plugins/nextgen-gallery/" title="Nextgen-Gallery Plugin" target="_blank">Nextgen-Gallery</a>'); ?><br />
    <? printf(__('%1$s is written by %2$s. Do you want to help? Please send me your translations!', 'nextgen-gallery-geo'), '<a href="http://wordpress.org/extend/plugins/nextgen-gallery-geo/" title="NextGEN Gallery Geo" target="_blank">NextGEN Gallery Geo</a>', '<a href="http://www.denktfrei.de" title="frest.de" target="_blank">Frederic Stuhldreier</a>'); ?>
    <br />
    <br /><br />
    
		<form action="options.php" method="post">
        
			<?php settings_fields('plugin_ngg_geo'); ?>
			<?php $options = get_option('plugin_ngg_geo_options'); ?>
            
            	<div id="sm_rebuild" class="postbox">
				<h3 style="font-family:Verdana, Geneva, sans-serif;"><p>&ensp;&ensp;<? _e('Geocoding', 'nextgen-gallery-geo'); ?> </p></h3>
				<div class="inside">
                
                
                <h4><? _e('Geocoding Provider', 'nextgen-gallery-geo'); ?><br /></h4>
             

                    <input type="radio" name="plugin_ngg_geo_options[geocoding_provider]" value="google_v2" <?php checked( $options['geocoding_provider'], "google_v2", 1 ); ?>> Google Maps Geocoder (v2)<br />
                    <input type="radio" name="plugin_ngg_geo_options[geocoding_provider]" value="google_v3" <?php checked( $options['geocoding_provider'], "google_v3", 1 ); ?>> Google Maps Geocoder (v3)<br />
                    <input type="radio" name="plugin_ngg_geo_options[geocoding_provider]" value="openstreetmaps" <?php checked( $options['geocoding_provider'], "openstreetmaps", 1 ); ?>> Openstreetmaps Nominatim<br />
                    <input type="radio" name="plugin_ngg_geo_options[geocoding_provider]" value="yahoo" <?php checked( $options['geocoding_provider'], "yahoo", 1 ); ?>> Yahoo! PlaceFinder <br /><br />
                     <input type="radio" name="plugin_ngg_geo_options[geocoding_provider]" value="no" <?php checked( $options['geocoding_provider'], "no", 1 ); ?>><? _e(' disable geocoding', 'nextgen-gallery-geo'); ?> <br /><br />
                    <span class="description"><? _e('The geocoding-function tries to to geocode the gallery-name, if there are no coordinates available. The usage of Google geocoding is only allowed, if you use google maps as well. If you want to use Yahoo!, you need a free AppID.', 'nextgen-gallery-geo'); ?></span>
                     <h4>AppID</h4>
                    <input type="text" class="regular-text" name="plugin_ngg_geo_options[geocoding_key]" value="<?php echo $options['geocoding_key']; ?>" /><br /><span class="description"><? printf(__('AppID for Geocoding (required for Yahoo!)', 'nextgen-gallery-geo'), '<a href="https://developer.apps.yahoo.com/dashboard/createKey.html" title="Yahoo! Place Finder" target="_blank">'); ?></span><br />
				 <h4>Shortcodes: <code>[nggg geocoding_provider=google_v2 / google_v3 / openstreetmaps / yahoo / no]</code></h4>
                </div>
				</div>
                
                
				<div id="sm_rebuild" class="postbox">
				<h3 style="font-family:Verdana, Geneva, sans-serif;"><p>&ensp;&ensp;<? _e('Map-layout', 'nextgen-gallery-geo'); ?>   </p></h3>
				<div class="inside">
					<h4><? _e('Zoomlevel', 'nextgen-gallery-geo'); ?> <code style="margin-left:30px;">shortcode: [nggg zoom=(1-19)]</code></h4>
                    <input type="text" class="regular-text" name="plugin_ngg_geo_options[zoom]" value="<?php echo $options['zoom'] ?>" /><br /><span class="description"><? _e('Which zoomlevel should be used? (maps with several pins are focused automatically)', 'nextgen-gallery-geo'); ?></span><br />
                    <h4><? _e('Map-height', 'nextgen-gallery-geo'); ?> <code style="margin-left:30px;">shortcode: [nggg map_height=100px]</code></h4>
                    <input type="text" class="regular-text code" name="plugin_ngg_geo_options[map_height]" value="<?php echo $options['map_height']; ?>" /><br /><span class="description"><? _e('You can use something like 235px or 78% - 235 does not work! <br /> Height and width of the maps can be changed directly by using CSS. The class is named <code>ngg_geo_map</code>', 'nextgen-gallery-geo'); ?></span><br />
                    <h4><? _e('Map-width', 'nextgen-gallery-geo'); ?> <code style="margin-left:30px;">shortcode: [nggg map_width=200px]</code></h4>
					<input type="text" class="regular-text code" name="plugin_ngg_geo_options[map_width]" value="<?php echo $options['map_width']; ?>" /><br />
                    <h4><? _e('Map-style', 'nextgen-gallery-geo'); ?> <code style="margin-left:30px;">shortcode: [nggg map= Aerial / Road / Hybrid]</code></h4>
                    <input type="radio" name="plugin_ngg_geo_options[map]" value="Aerial" <?php checked( $options['map'], "Aerial", 1 ); ?>> <? _e('Aerial', 'nextgen-gallery-geo'); ?><br /><br />
       				<input type="radio" name="plugin_ngg_geo_options[map]" value="Hybrid" <?php checked( $options['map'], "Hybrid", 1 ); ?>> <? _e('Hybrid', 'nextgen-gallery-geo'); ?><br /><br />
       				<input type="radio" name="plugin_ngg_geo_options[map]" value="Road" <?php checked( $options['map'], "Road", 1 ); ?>> <? _e('Road', 'nextgen-gallery-geo'); ?><br /><br />
                    <h4><input type="checkbox" name="plugin_ngg_geo_options[bev]" value="1" <?php checked( $options['bev'], 1 ); ?>>  &ensp; &ensp;  <? _e("Use Bird's-eye view", 'nextgen-gallery-geo'); ?><code style="margin-left:30px;">shortcode: [nggg bev= 1 / 0]</code></h4><span class="description"><? _e("Should the Bird's-eye view be used, if available? (a Bing-feature)", 'nextgen-gallery-geo'); ?></span><br /><br />
		        	<h4><? _e("Which elements should be displayed?", 'nextgen-gallery-geo'); ?><code style="margin-left:30px;">shortcode: [nggg dashboard= 1 / 0 minimap= 1 / 0 scalebar= 1 / 0]</code></h4>
                    <input type="checkbox" name="plugin_ngg_geo_options[dashboard]" value="1" <?php checked( $options['dashboard'], 1 ); ?>>  &ensp; &ensp;  <? _e("Dashboard", 'nextgen-gallery-geo'); ?><br />
                    <input type="checkbox" name="plugin_ngg_geo_options[minimap]" value="1" <?php checked( $options['minimap'], 1 ); ?>>  &ensp; &ensp;  <? _e("Minimap", 'nextgen-gallery-geo'); ?><br />
                    <input type="checkbox" name="plugin_ngg_geo_options[scalebar]" value="1" <?php checked( $options['scalebar'], 1 ); ?>>  &ensp; &ensp;  <? _e("Scalebar", 'nextgen-gallery-geo'); ?><br />
                 </div>
    			</div>
                
                
				<div id="sm_rebuild" class="postbox">
				<h3 style="font-family:Verdana, Geneva, sans-serif;"><p>&ensp;&ensp;<? _e('Thumbnails', 'nextgen-gallery-geo'); ?>   </p></h3>
				<div class="inside">
                	<input type="radio" name="plugin_ngg_geo_options[thumb]" value="2" <?php checked( $options['thumb'], "2", 2 ); ?>> <? _e('phpThumb thumbnails', 'nextgen-gallery-geo'); ?><br /><span class="description"><? _e('phpThumb uses <code>/thumbs/images/nggg.png</code> for the glossy effect. You can edit this file, to try other styles.', 'nextgen-gallery-geo'); ?></span><br /><br />
    				<input type="radio" name="plugin_ngg_geo_options[thumb]" value="3" <?php checked( $options['thumb'], "3", 3 ); ?>> <? _e('CSS 3 styled thumbnails', 'nextgen-gallery-geo'); ?><br /><span class="description"><? _e('works faster, old browsers does not support this feature', 'nextgen-gallery-geo'); ?></span><br /><br />
                    <input type="radio" name="plugin_ngg_geo_options[thumb]" value="4" <?php checked( $options['thumb'], "4", 4 ); ?>> <? _e('use pushpins instead of thumbnails', 'nextgen-gallery-geo'); ?><br />
					<br /><code>shortcode: [nggg thumb=(2 ~ phpThumb, 3 ~ CSS3, 4 ~ pushpins)]</code>
                   	<h4><? _e('Thumbnail height', 'nextgen-gallery-geo'); ?><code style="margin-left:30px;">shortcode: [nggg thumb_height=40px]</code></h4>
					<input type="text" class="regular-text code" name="plugin_ngg_geo_options[thumb_height]" value="<?php echo $options['thumb_height']; ?>" /><br /><span class="description"><? _e('You can use something like 235px or 78% - 235 does not work! <br /> Height and width of the maps can be changed directly by using CSS. The class is named <code>ngg_geo_thumb</code>', 'nextgen-gallery-geo'); ?></span><br />  			
                    <h4><? _e('Thumbnail width', 'nextgen-gallery-geo'); ?><code style="margin-left:30px;">shortcode: [nggg thumb_width=40px]</code></h4>
					<input type="text" class="regular-text code" name="plugin_ngg_geo_options[thumb_width]" value="<?php echo $options['thumb_width']; ?>" /><br />
                    
                    
					<h4><input type="checkbox" name="plugin_ngg_geo_options[thumb_desc]" value="1" <?php checked( $options['thumb_desc'], 1 ); ?>>  &ensp; &ensp;  <? _e("show thumbnail descriptions", 'nextgen-gallery-geo'); ?><code style="margin-left:30px;">shortcode: [nggg thumb_desc= 1 / 0]</code></h4><span class="description"><? _e(" The style of this box can be changed by using CSS. The class is named <code>ngg_geo_map_pushpin_desc</code>", 'nextgen-gallery-geo'); ?></span><br /><br />
                
                </div>
    			</div>
                
                
				<div id="sm_rebuild" class="postbox">
				<h3 style="font-family:Verdana, Geneva, sans-serif;"><p>&ensp;&ensp;<? _e('Infobox', 'nextgen-gallery-geo'); ?>   </p></h3>
				<div class="inside">
                <h4><? _e('Lightbox', 'nextgen-gallery-geo'); ?><code style="margin-left:30px;">shortcode: [nggg lightbox= Fancybox / Slimbox / no]</code></h4>
            		<input type="radio" name="plugin_ngg_geo_options[lightbox]" value="Fancybox" <?php checked( $options['lightbox'], "Fancybox", 1 ); ?>> Fancybox<br />
       				<input type="radio" name="plugin_ngg_geo_options[lightbox]" value="Slimbox" <?php checked( $options['lightbox'], "Slimbox", 1 ); ?>> Slimbox<br />
       				<input type="radio" name="plugin_ngg_geo_options[lightbox]" value="no" <?php checked( $options['lightbox'], "no", 1 ); ?>> <? _e("no lightbox-plugin", 'nextgen-gallery-geo'); ?><br /><br />
                     <span class="description"><? _e('You can choose between two different Lightbox-plugins. These plugins are already included.', 'nextgen-gallery-geo'); ?></span><br /><br />
                     <h4><input type="checkbox" name="plugin_ngg_geo_options[exif]" value="1" <?php checked( $options['exif'], 1 ); ?>> &ensp;&ensp; <? _e('show detailed EXIF informations, if available', 'nextgen-gallery-geo'); ?><code style="margin-left:30px;">shortcode: [nggg exif= 1 / 0]</code></h4>
    			</div> 
                </div> 
                

				<div id="sm_rebuild" class="postbox">
				<h3 style="font-family:Verdana, Geneva, sans-serif;"><p>&ensp;&ensp;<? _e('Routes', 'nextgen-gallery-geo'); ?>   </p></h3>
				<div class="inside">
                	<h4><? _e('Polyline width', 'nextgen-gallery-geo'); ?><code style="margin-left:30px;">shortcode: [nggg route_width=5]</code></h4>
                    <input type="text" class="regular-text" name="plugin_ngg_geo_options[route_width]" value="<?php echo $options['route_width']; ?>" /><br />
                    <h4><? _e('Polyline color', 'nextgen-gallery-geo'); ?><code style="margin-left:30px;">shortcode: [nggg route_color=]</code></h4>
                    <input type="text" class="regular-text" name="plugin_ngg_geo_options[route_color]" value="<?php echo $options['route_color']; ?>" /><br /><span class="description"><? _e('Choose the polyline color. Format: RGB <code>red, green, blue, alpha transparency</code>. You can use <a href="http://www.colorschemer.com" title="colorschemer.com" target="_blank">colorschemer.com</a> to find colors.', 'nextgen-gallery-geo'); ?></span><br />
                	<h4><input type="checkbox" name="plugin_ngg_geo_options[route]" value="1" <?php checked( $options['route'], 1 ); ?>>  &ensp; &ensp;  <? _e("activate route-mode for all maps", 'nextgen-gallery-geo'); ?><code style="margin-left:30px;">shortcode: [nggg route= 1 / 0]</code></h4><span class="description"><? _e("If activated, route mode will be activated for all maps with more than one picture.", 'nextgen-gallery-geo'); ?></span><br />
    			</div>
    			</div>  
 
                
                <div id="sm_rebuild" class="postbox">
				<h3 style="font-family:Verdana, Geneva, sans-serif;"><p>&ensp;&ensp;<? _e('How should the maps be included?', 'nextgen-gallery-geo'); ?>   </p></h3>
				<div class="inside">
                	<input type="checkbox" name="plugin_ngg_geo_options[auto_mode]" value="1" <?php checked( $options['auto_mode'], 1 ); ?>> <? _e('automatically, when a gallery is used (recommended)', 'nextgen-gallery-geo'); ?><br />
    			</div>
    			</div> 
                

              	<div id="sm_rebuild" class="postbox">
				<h3 style="font-family:Verdana, Geneva, sans-serif;"><p>&ensp;&ensp;<? _e('Preview Map', 'nextgen-gallery-geo'); ?>   </p></h3>
				<div class="inside">
                	<? $example_map = ng_gallery_geo_example(); echo ng_gallery_geo("", $example_map, NULL); ?>
    			</div>
    			</div>
            


			<p class="submit">
			<input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
			</p>
		</form>
	</div>
	

	<?php	
}
?>
