<?php
// function: init
add_action( 'init', 'ng_gallery_geo_init' );
function ng_gallery_geo_init() 	
{
	//get options
	$options = get_option('plugin_ngg_geo_options');
	
	//add I18n
	load_plugin_textdomain( 'nextgen-gallery-geo', false, 'nextgen-gallery-geo/lang' );
	
	//add mapcontrol v.6.3
	wp_register_script( 'bing-maps', 'http://ecn.dev.virtualearth.net/mapcontrol/mapcontrol.ashx?v=6.3&mkt='.get_bloginfo ("language"));
    wp_enqueue_script( 'bing-maps' );
	
	//add jquery
	wp_enqueue_script( 'jquery' );
	
	//add lightbox
	
		//add fancybox (if needed!)
		if ($options['lightbox'] == "Fancybox")
		{
		wp_register_script( 'fancybox', plugins_url().'/nextgen-gallery-geo/js/fancybox/jquery.fancybox.js?v=2.0.6');
		wp_enqueue_script( 'fancybox' );
		}
		
		if ($options['lightbox'] == "Slimbox")
		{
		//add slimbox (if needed!)
		wp_register_script( 'slimbox', plugins_url().'/nextgen-gallery-geo/js/slimbox/js/slimbox2.js');
		wp_enqueue_script( 'slimbox' );
		}


		// add ajax javascript
		wp_register_script( 'ajax', plugins_url().'/nextgen-gallery-geo/js/ajax.js');
		wp_enqueue_script( 'ajax' );
		wp_localize_script( 'ajax', 'MyAjax', array(
			'ajaxurl'          => admin_url( 'admin-ajax.php' )
		)
		);

		//add ajax lightbox (for worldmap)
		add_action('wp_ajax_ngg_geo_lightbox', 'ngg_geo_lightbox_callback');
		add_action('wp_ajax_nopriv_ngg_geo_lightbox', 'ngg_geo_lightbox_callback');
		//add ajax (show map)
		add_action('wp_ajax_ngg_geo_showmap', 'ng_gallery_geo_shortcodes_ajax');
		add_action('wp_ajax_nopriv_ngg_geo_showmap', 'ng_gallery_geo_shortcodes_ajax');


}



// function: add header
add_action('wp_print_scripts', 'ng_gallery_geo_header');

function ng_gallery_geo_header() 
{

echo 		
"\n".'	<!-- NextGen Gallery geo plugin by Frederic Stuhldreier - frest.de -->
	<link rel="stylesheet" href="'.get_bloginfo("wpurl").'/wp-content/plugins/nextgen-gallery-geo/css/style.css" type="text/css" media="screen" />
	<link rel="stylesheet" href="'.get_bloginfo("wpurl").'/wp-content/plugins/nextgen-gallery-geo/js/fancybox/jquery.fancybox.css?v=2.0.6" type="text/css" media="screen" />
	<link rel="stylesheet" href="'.get_bloginfo("wpurl").'/wp-content/plugins/nextgen-gallery-geo/js/slimbox/css/slimbox2.css" type="text/css" media="screen" />
	<!-- / NextGen Gallery geo plugin -->'."\n\n";
}
		
// function: calculate coordinates
function ng_gallery_geo_coordinates($picture_path)
{
	// get exif data
	if ($exif = @exif_read_data($picture_path, 0 , false))
			{
				// any coordinates available?
				
					if (!isset ($exif['GPSLongitude'][0])) {return false;}
					{
					// south or west?
					if ($exif['GPSLatitudeRef'] == "S") {$gps['latitude_string'] = -1; $gps['latitude_dicrection'] = "S";} else {$gps['latitude_string'] = 1; $gps['latitude_dicrection'] = "N";}
					if ($exif['GPSLongitudeRef'] == "W") {$gps['longitude_string'] = -1; $gps['longitude_dicrection'] = "W";} else {$gps['longitude_string'] = 1; $gps['longitude_dicrection'] = "E";}
					
					 $gps['latitude_hour'] = $exif["GPSLatitude"][0];
					 $gps['latitude_minute'] = $exif["GPSLatitude"][1];
					 $gps['latitude_second'] = $exif["GPSLatitude"][2];
					 $gps['longitude_hour'] = $exif["GPSLongitude"][0];
					 $gps['longitude_minute'] = $exif["GPSLongitude"][1];
					 $gps['longitude_second'] = $exif["GPSLongitude"][2]; 
						
						
							// calculating 
								foreach($gps as $key => $value) {
								$pos = strpos($value, '/');
								if($pos !== false) 
								{$temp = explode('/',$value); $gps[$key] = $temp[0] / $temp[1];}
								}
		 
		
					$geo['latitude_format'] = $gps['latitude_dicrection']." ".$gps['latitude_hour']."&deg;".$gps['latitude_minute']."&#x27;".round ($gps['latitude_second'], 4).'&#x22;';
					$geo['longitude_format'] = $gps['longitude_dicrection']." ".$gps['longitude_hour']."&deg;".$gps['longitude_minute']."&#x27;".round ($gps['longitude_second'], 4).'&#x22;';
					 
					$geo['latitude'] = $gps['latitude_string'] * ($gps['latitude_hour'] + ($gps['latitude_minute'] / 60) + ($gps['latitude_second'] / 3600));
					$geo['longitude'] = $gps['longitude_string'] * ($gps['longitude_hour'] + ($gps['longitude_minute'] / 60) + ($gps['longitude_second'] / 3600));	
					}
			}
			else {return false;}
			
			return $geo;
			
	
}

// function: get exif data
function ng_gallery_geo_exif($picture_data)
{
      $exif_ifd0 = read_exif_data($picture_data->imagePath ,'IFD0' ,0);       
      $exif_exif = read_exif_data($picture_data->imagePath ,'EXIF' ,0);
      
	  // timestamp
      if (@array_key_exists('DateTime', $exif_ifd0)) {
        $picture_data->meta_data['created_timestamp'] = $exif_ifd0['DateTime'];
		if (isset($exif_ifd0["DateTimeOriginal"])) {$picture_data->meta_data['created_timestamp'] = str_replace(":","-",substr($exif_ifd0["DateTimeOriginal"], 0, 10))."  ".substr($exif_ifd0["DateTimeOriginal"], 10);}
      } 
      
      // camera
      if (@array_key_exists('Make', $exif_ifd0) AND @array_key_exists('Model', $exif_ifd0)) {
        $picture_data->meta_data['camera'] = $exif_ifd0['Make']." ".$exif_ifd0['Model'];
      } 
	  
	  // aperture
      if (@array_key_exists('ApertureFNumber', $exif_ifd0['COMPUTED'])) {
        $picture_data->meta_data['aperture'] = $exif_ifd0['COMPUTED']['ApertureFNumber'];
      } 
	  
	  // focal length
	   if (@array_key_exists('FocalLength', $exif_ifd0)) {
	   list($num, $den) = explode("/", $exif_ifd0['FocalLength']);
	   $picture_data->meta_data['focal_length']  = ($num/$den) . "mm";
	   }  

	  // iso
      if (@array_key_exists('ISOSpeedRatings',$exif_exif)) {
        $picture_data->meta_data['iso'] = $exif_exif['ISOSpeedRatings'];
      } 
      
      // shutter speed
      if (@array_key_exists('ExposureTime', $exif_ifd0)) {
        $picture_data->meta_data['shutter_speed'] = $exif_ifd0['ExposureTime'];
      } 

return $picture_data;
}

// function: add pin

function ngg_geo_add_pin ($picture_data, $picture_nr, $picture_nr_total, $options)
{
	$pin =	'var loc_'.$picture_nr.' = new VELatLong('.$picture_data->gps['latitude'].','.$picture_data->gps['longitude'].');'."\n";
	$pin .=	'var pin_'.$picture_nr.' = new VEShape(VEShapeType.Pushpin, loc_'.$picture_nr.');'."\n";
	
	// use a custom icon or the pushpin?
	if ($options['thumb'] != 4) {$pin .= ngg_geo_thumbnail ($picture_data, $picture_nr, $picture_nr_total, $options);}

	// add individual ajax nonce (used by worldmap)
	if ($options['worldmap'] == 1) {$pin .= 'wmn'.$picture_data->gid.' = "'.$picture_data->gid.",".wp_create_nonce( "myajax-lightbox-nonce-$picture_data->gid" ).",".$options['lightbox']."\";\n";}

	$pin .= 'pin_'.$picture_nr.'.SetTitle("'.$picture_data->title.'");'."\n";
	$pin .= 'pin_'.$picture_nr.'.SetDescription(\''.ngg_geo_pin_desc ($picture_data, $picture_nr_total, $options).'\');'."\n";
	$pin .= 'map_'.$options['mid'].'.AddShape(pin_'.$picture_nr.');'."\n";
	$pin .=  'locs.push(loc_'.$picture_nr.');'."\n \n";
	

	return $pin;
}

// function: get thumbnail

function ngg_geo_thumbnail ($picture_data, $picture_nr, $picture_nr_total, $options)
{
	//use thumb description?
	if ($options['thumb_desc'] == 1) 
		{
			// map (picture alttext)
			if ($options['status'] != "worldmap") {$description = '<p class=\'ngg_geo_map_pushpin_desc\'>'.$picture_data->alttext.'</p>';}
			
			// worldmap (gallery title)
			else {$description = '<p class=\'ngg_geo_map_pushpin_desc\'>'.$picture_data->title.'</p>';}
		} 
		
	else {$description = NULL;}
	
		//css 3 
		if ($options['thumb'] == 3) 
		{
			$link = $picture_data->thumbURL;
			$thumb = 'pin_'.$picture_nr.'.SetCustomIcon("<div onclick=\'ngg_geo_lightbox_'.$options['mid'].'('.$picture_nr_total.')\' class=\'ngg_geo_thumb\' style=\'width:'.$options['thumb_width'].'; height:'.$options['thumb_height'].'\'><img src=\''.$link.'\' /></div><div style=\'height:'.$options['thumb_height'].'; margin: 20px;\' class=\'ngg_geo_thumb_spacer\'></div>'.$description.'");'."\n";
			return $thumb;
		}
		
		//phpThumb()
		if ($options['thumb'] == 2) 
		{
			require_once('thumbs/phpThumb.config.php'); $link = "/wp-content/plugins/nextgen-gallery-geo/thumbs/".phpThumbURL('src='.$picture_data->imagePath.'&fltr[]=over|images/nggg.png|0&w='.$options['thumb_width'].'&h='.$options['thumb_height'].'&zc=1');
			$thumb = 'pin_'.$picture_nr.'.SetCustomIcon("<img src=\''.$link.'\' onclick=\'ngg_geo_lightbox_'.$options['mid'].'('.$picture_nr_total.')\' />'.$description.'");'."\n";
			return $thumb;
		}
		
}

// function: pin description

function ngg_geo_pin_desc ($picture_data, $picture_nr_total, $options)
{
	//gallery description
	$pin_desc = htmlspecialchars($picture_data->galdesc, ENT_QUOTES);
	
	//image
	$pin_desc .= '<br /><br /><img src="'.$picture_data->imageURL.'" style="cursor:pointer;"  height="165px" alt="%5$s" onclick="ngg_geo_lightbox_'.$options['mid'].'('.$picture_nr_total.')" /><br /><br />';
	
	//picture description
	if (strlen ($picture_data->description) > 1) {$pin_desc .= htmlspecialchars($picture_data->description, ENT_QUOTES)."<br /><br />";}
	
	//coordinates
	if (isset($picture_data->gps['longitude_format'])) {$pin_desc .=  '<b>'.__('GPS coordinates', 'nextgen-gallery-geo').'</b><br />'.__('longitude', 'nextgen-gallery-geo').':  '.$picture_data->gps['longitude_format'].'<br />'.__('latitude', 'nextgen-gallery-geo').':  '.$picture_data->gps['latitude_format'];}
	
	//exif
	if ($options['exif'] == 1)
	{	
		// @ needed, otherwise "Notice: Undefined property:"
		if (@strlen ($picture_data->meta_data['created_timestamp']) > 2 or @strlen ($picture_data->meta_data['camera']) > 2 or @strlen ($picture_data->meta_data['aperture']) > 2 or @strlen ($picture_data->meta_data['iso'] > 2))
		{$pin_desc .= '<br /><br /><b>EXIF</b><br />';} 
				
		if (strlen (@$picture_data->meta_data['created_timestamp']) > 2) {$pin_desc .= __('date', 'nextgen-gallery-geo').":  ".$picture_data->meta_data['created_timestamp']."<br />";}
		if (strlen (@$picture_data->meta_data['camera']) > 2) {$pin_desc .= __('camera', 'nextgen-gallery-geo').":  ".$picture_data->meta_data['camera']."<br />";}
		if (strlen (@$picture_data->meta_data['aperture']) > 2 and strlen ($picture_data->meta_data['focal_length']) > 2) {$pin_desc .= __('aperture', 'nextgen-gallery-geo').": ".$picture_data->meta_data['aperture'].", ".__('focal_length', 'nextgen-gallery-geo').": ".$picture_data->meta_data['focal_length']."<br />";}
		if (strlen (@$picture_data->meta_data['iso']) > 2 and strlen ($picture_data->meta_data['shutter_speed']) > 2) {$pin_desc .= __('iso', 'nextgen-gallery-geo').": ".$picture_data->meta_data['iso'].", ".__('shutter_speed', 'nextgen-gallery-geo').": ".$picture_data->meta_data['shutter_speed'];}
	}

	//gallery lightbox link (used by worldmap)
	if ($options['worldmap'] == 1) {$pin_desc .= '<br /><br /><a href="#" onclick="lightbox_ajax(wmn'.$picture_data->gid.')">'.__('More photos of this gallery', 'nextgen-gallery-geo').'</a>';}
	
	
	return $pin_desc;
}

// function: lightbox ajax callback via sql

function ngg_geo_lightbox_callback()
{
	
	// nonce security
	$data = $_POST['gid'];
	$post = explode(",", $data);
	$gid = $post[0];
	$nonce = $post[1];
	$lightbox_type = $post[2];
	
	if ( ! wp_verify_nonce( $nonce, 'myajax-lightbox-nonce-'.$gid ) )	{die ( 'Busted!');}
	
	// get data using sql
	global $wpdb;
	$wpdb->ngg_gallery = $wpdb->prefix."ngg_gallery";
	$wpdb->ngg_pictures = $wpdb->prefix."ngg_pictures";
	$picturelist = $wpdb->get_results( 
	"SELECT description, filename, path, exclude
	FROM $wpdb->ngg_pictures, $wpdb->ngg_gallery
	WHERE $wpdb->ngg_pictures.galleryid = $gid AND $wpdb->ngg_gallery.gid = $gid", OBJECT );
	
	// create lightbox data
	
		// fancybox
		if ($lightbox_type == "Fancybox")
		{
		$lightbox .= 'jQuery.fancybox.open([ ';
				foreach ($picturelist as $picture) 
				{	
					// exclude?
					if ($picture->exclude == 1) {continue;}
					
					$lightbox .= '{href : "'.site_url()."/".$picture->path."/".$picture->filename.'", title : "'.$picture->description.'"},';
				}
		$lightbox .= ' ], {padding : 0} ) ;';
		}
	
		// slimbox
		if ($lightbox_type == "Slimbox")
		{
		$lightbox .= 'jQuery.slimbox(['."\n";
				foreach ($picturelist as $picture) 
				{	
					// exclude?
					if ($picture->exclude == 1) {continue;}
					
					$lightbox .= '["'.site_url()."/".$picture->path."/".$picture->filename.'", "'.$picture->description.'"],';
				}
		$lightbox .= '], 1);';
		}

	echo $lightbox;
	die;
}

// function: collect lightbox data

function ngg_geo_lightbox_data($picture_data, $type, $picture_nr_total)
{
	if ($type == "no") return;
	
	// Fancybox
	if ($type == "Fancybox")
	{
	$data = '{href : "'.$picture_data->imageURL.'", title : "'.$picture_data->description.'"},';
	}
	
	//Slimbox
	if ($type == "Slimbox")
	{
		if ($picture_nr_total == 0) 	{$data = '["'.$picture_data->imageURL.'", "'.$picture_data->description.'"]';}
		else							{$data .= ','."\n".'["'.$picture_data->imageURL.'", "'.$picture_data->description.'"]';}
	}
	
	return $data;
}
			
// function: geocode

			function ngg_geo_geocode ($location, $options)
			{
				
				if ($options['geocoding_provider'] == "google_v2")
				{
							$geo = file('http://maps.google.com/maps/geo?q='.rawurlencode("$location").'&output=csv');
							$response = split(",", $geo[0]);
							if ($response[0] == 200){
							$gps['latitude'] = $response[2];
							$gps['longitude'] = $response[3];
			
							// zu ungenau!
							if ($response[1] < 2) {return false;}
			
							}else{
							// Fehler
							return false;
							}
							
						 	return $gps;
				}
				
				if ($options['geocoding_provider'] == ('google_v3'))
				
				{
							$jsonfile = file_get_contents('http://maps.google.com/maps/api/geocode/json?address='.rawurlencode($location).'&sensor=true');
							$jsonarray = json_decode($jsonfile, TRUE);
							
							// Fehler: keine Koordinaten
							if  ($jsonarray["status"] == "INVALID_REQUEST" or $jsonarray["status"] == "ZERO_RESULTS" ) {return false;}	
							
							$gps['latitude'] = $jsonarray["results"][0]["geometry"]["location"]["lat"];
							$gps['longitude'] = $jsonarray["results"][0]["geometry"]["location"]["lng"];
							return $gps;
				}
				
				if ($options['geocoding_provider'] == ('openstreetmaps'))
				
				{
							$jsonfile = file_get_contents('http://nominatim.openstreetmap.org/search/?format=json&addressdetails=1&limit=1&q='.rawurlencode($location));
							// Fehler: keine Koordinaten
							if (!json_decode($jsonfile, TRUE)) {return false;}
							
							$jsonarray = json_decode($jsonfile, TRUE);
							$gps['latitude'] = $jsonarray[0]['lat'];
							$gps['longitude'] = $jsonarray[0]['lon'];
							return $gps;
				}
				
				if ($options['geocoding_provider'] == ('yahoo'))
				
				{
							$jsonfile = file_get_contents('http://where.yahooapis.com/geocode?appid='.$options['geocoding_key'].'&count=1&flags=JC&q='.rawurlencode($location));
							$jsonarray = json_decode($jsonfile, TRUE);
							
							// Fehler: keine Koordinaten
							if ($jsonarray['ResultSet']['Found'] == 0) {return false;}
							
							$gps['latitude'] = $jsonarray['ResultSet']['Results'][0]['latitude'];
							$gps['longitude'] = $jsonarray['ResultSet']['Results'][0]['longitude'];
							return $gps;
				}
			}
			
// function: get .gpx data (routemode)
function ngg_geo_gpx($dir)
{
	if ($file = simplexml_load_file($dir))
	{
	$key = 0;
	$out = 'var gpxs = [];'."\n";
		foreach ($file->trk->trkseg->trkpt as $value) 
		{
			$out .= 'var gpx_'.$key.' = new VELatLong('.strval($value["lat"]).','.strval($value["lon"]).');'."\n";
			$out .= 'gpxs.push(gpx_'.$key.');'."\n";
			++$key;
		}
	return $out;
	}
	
	else {return false;}
}


// function: get gallery id
function ngg_geo_get_id ($text)
{	
		if(strpos($text,"[nggallery id=")!==false) {$first = strpos ( $text, '[nggallery id=' );	$position = (14 + $first);}
		else {if(strpos($text,"[gallery=")!==false)	  {$first = strpos ( $text, '[gallery=' );	$position = (9 + $first);}
			
			else	{return false;}}
		
		$gallery_id = $text[$position];
		
		// how long is the id?
		if (is_numeric($text[($position + 1)])) {$gallery_id = $text[$position].$text[($position + 1)];
		if (is_numeric($text[($position + 2)])) {$gallery_id = $text[$position].$text[($position + 1)].$text[($position + 2)];
		if (is_numeric($text[($position + 3)])) {$gallery_id = $text[$position].$text[($position + 1)].$text[($position + 2)].$text[($position + 3)];}}}
		return $gallery_id;
}


// validate options (adminstration)
function ngg_geo_options_admin($input) 
{
	//clear define checkboxes (undefined = unchecked!)
	if (!isset ($input['bev'])) {$input['bev'] = 0;}
	if (!isset ($input['exif'])) {$input['exif'] = 0;}
	if (!isset ($input['route'])) {$input['route'] = 0;}
	if (!isset ($input['auto_mode'])) {$input['auto_mode'] = 0;}
	if (!isset ($input['dashboard'])) {$input['dashboard'] = 0;}
	if (!isset ($input['minimap'])) {$input['minimap'] = 0;}
	if (!isset ($input['scalebar'])) {$input['scalebar'] = 0;}
	
	//unset empty variables (otherwise wp_parse_args wont work)
	foreach ($input as $key => $line) 	{if (strlen($line) == 0) {  unset ($input[$key]);}}
	
	
	// validate options
	if (!is_numeric($input['zoom']) OR $input['zoom'] > 19 OR $input['zoom'] < 1) {unset ($input['zoom']);} 
	if (!is_numeric($input['route_width'])) {unset ($input['route_width']);} 
	if (is_numeric($input['map_height'])) {$input['map_height'] .= "px";} 
	if (is_numeric($input['map_width'])) {$input['map_width'] .= "px";} 


	// $options defaults
	$defaults = 
	array(
		'geocoding_key' 			=>		 	NULL,
		'geocoding_provider'		=>			'google_v3',
		'zoom'						=>			'16',
		'map_height'				=>   		'300px', 
		'map_width'					=>			'400px', 
		'map'						=>  		'Aerial',
		'bev'						=>			'1',
		'thumb'						=>			'1',
		'lightbox'					=>			'Fancybox',
		'exif'						=>			'1',
		'route_width'				=>			'5',
		'route_color'				=>			'0,0,255,.2',
		'route'						=>			'1',
		'auto_mode'					=>			'1',			// auto-mode activated?
		'worldmap'					=>			'0',
		
		'dashboard'					=>			'0',
		'minimap'					=>			'0',
		'scalebar'					=>			'0',
		'thumb_desc'				=>			'0',
		'thumb_height'				=>			'100px',
		'thumb_width'				=> 			'100px',
		

/*		
	other options:

		'id' 						=> NULL,					// gallery id
		'pid'					 	=> NULL,					// picture id
		'worldmap' 					=> NULL,					// show worldmap?
		'ajax' 						=> NULL,					// show ajax link or map?
		'status'					=> NULL,					// status: which mode is used actual? (auto, worldmap..)
*/
	
	);
	
	//parse it
	$input = wp_parse_args( $input, $defaults );
	
	return $input;
}

// add shortcodes
add_shortcode( 'nggg', 'ng_gallery_geo_shortcodes' );

function ng_gallery_geo_shortcodes( $options )
{
	//mid must be a number
	if (empty ($options['mid']) OR !is_numeric ($options['mid'])) {$options['mid'] = mt_rand(0, 999);}

	//use ajax?
	if ($options['ajax'] == 1) 
	{
		// get options (map size needed)
		$default_options = get_option('plugin_ngg_geo_options');
		$options = wp_parse_args( $options, $default_options );
		
		// create nonce
		$options['pid'] = ""; 
		$options['nonce'] = wp_create_nonce( "ngg_geo-showpost-".$options['id']."-".$options['pid']."-".$options['worldmap']."" );
		
		$out = "\n\n".'<!-- begin NextGEN Gallery geo -->'."\n";
		
		//serualize options
		$out .= "<script>nggg_options_".$options['mid']." = '".base64_encode(serialize($options))."'; </script>"."\n";
		
		$out .= '<div id="ngg-geo-'.$options['mid'].'" style="display: none;"></div>'."\n";
		$out .= '<p class="geo_slide" style="width: '.$options["map_width"].';"><a href="#" id="geo_slide_'.$options['mid'].'" class="geo-btn-slide" onclick="showmap_ajax(nggg_options_'.$options['mid'].', '.$options['mid'].')">'.__('Map', 'nextgen-gallery-geo').'</a></p>'."\n";
		
		$out .= '<!-- end NextGEN Gallery geo -->'."\n\n";
		return $out;
	}
	
	//worldmap shortcode
	if ($options['worldmap'] == 1) {return ngg_geo_worldmap($options);}
	
	//single picture shortcode
	if (is_numeric($options['pid'])) {return ng_gallery_geo_data_single($options);}
	
	//normal map
	else {return ng_gallery_geo_data($options);}
}

// function: shortcodes ajax show (prepare shortcodes for ajax)
function ng_gallery_geo_shortcodes_ajax()
{

	$options = unserialize(base64_decode($_POST['options']));
	
	// unset ajax, no loop.. ;)
	$options['ajax'] = 0;

	// nonce security
	if ( ! wp_verify_nonce( $options['nonce'], "ngg_geo-showpost-".$options['id']."-".$options['pid']."-".$options['worldmap'] ) )	{die ( 'Busted!');}
	
 	echo ng_gallery_geo_shortcodes($options);
	die;
}


// function: auto mode
// get options
$ngg_geo_option = get_option('plugin_ngg_geo_options');

if ($ngg_geo_option['auto_mode'] == 1) 	
{
	add_filter('ngg_gallery_output', 'ng_gallery_geo_auto', 10, 2);
	add_filter('the_content', 'ng_gallery_geo_no_shortcode');
	
	function ng_gallery_geo_auto($out, $picturelist)
	{
		$options['status'] = "auto";
		return ng_gallery_geo ($out, $picturelist, $options);
	}
	
	// remove shortcodes
	function ng_gallery_geo_no_shortcode($content)	{$content = str_replace('[nggg]', '', $content); return $content;}
}


// function: get data via sql, used for nggg id= shortcode
function ng_gallery_geo_data($options = NULL)

	{	
		// get the gallery id, if needed
		if (!isset ($options['id'])) {$content = get_the_content(); $options['id'] = ngg_geo_get_id($content);}
	
		// SQL: get gallery data
		global $wpdb;
		$wpdb->ngg_gallery = $wpdb->prefix."ngg_gallery";
		$wpdb->ngg_pictures = $wpdb->prefix."ngg_pictures";

		$picturelist = $wpdb->get_results( 
		"SELECT path, filename, title, galdesc, gid, description, meta_data, alttext, exclude
		FROM $wpdb->ngg_pictures, $wpdb->ngg_gallery
		WHERE $wpdb->ngg_pictures.galleryid = ".$options['id']." AND $wpdb->ngg_gallery.gid = ".$options['id'], OBJECT );
		
		foreach ($picturelist as $key => $picture) 
		{
			// exclude?
			if ($picture->exclude == 1) {continue;}
			
			$picturelist[$key]->imageURL = site_url()."/".$picture->path."/".$picture->filename;
			$picturelist[$key]->thumbURL = site_url()."/".$picture->path."/thumbs/thumbs_".$picture->filename;
			$picturelist[$key]->imagePath = $_SERVER['DOCUMENT_ROOT']."/".$picture->path."/".$picture->filename;
			$picturelist[$key]->thumbPath = $_SERVER['DOCUMENT_ROOT']."/".$picture->path."/thumbs/thumbs_".$picture->filename;
			$picturelist[$key]->meta_data = unserialize($picture->meta_data);
			
		}

		return ng_gallery_geo("", $picturelist, $options);
	}
	
// function: get single picture data via sql, used for nggg pid= shortcode
function ng_gallery_geo_data_single($options = NULL)

	{		
		// SQL: get gallery data
		global $wpdb;
		$wpdb->ngg_gallery = $wpdb->prefix."ngg_gallery";
		$wpdb->ngg_pictures = $wpdb->prefix."ngg_pictures";

		$picturelist = $wpdb->get_results( 
		"SELECT path, filename, title, galdesc, gid, description, meta_data, alttext, exclude
			FROM $wpdb->ngg_pictures, $wpdb->ngg_gallery
			WHERE $wpdb->ngg_pictures.galleryid = $wpdb->ngg_gallery.gid AND $wpdb->ngg_pictures.pid = ".$options['pid'], OBJECT );
		
		foreach ($picturelist as $key => $picture) 
		{
			// exclude?
			if ($picture->exclude == 1) {return;}
			
			$picturelist[$key]->imageURL = site_url()."/".$picture->path."/".$picture->filename;
			$picturelist[$key]->thumbURL = site_url()."/".$picture->path."/thumbs/thumbs_".$picture->filename;
			$picturelist[$key]->imagePath = $_SERVER['DOCUMENT_ROOT']."/".$picture->path."/".$picture->filename;
			$picturelist[$key]->thumbPath = $_SERVER['DOCUMENT_ROOT']."/".$picture->path."/thumbs/thumbs_".$picture->filename;
			$picturelist[$key]->meta_data = unserialize($picture->meta_data);
		}
		
		return ng_gallery_geo("", $picturelist, $options);
	}
	
// function: show map using a php function
function ng_gallery_geo_show($options = NULL)
{
	echo ng_gallery_geo_data($options);
}


// worldmap


		// show worldmap via function
		function ng_gallery_geo_show_worldmap($options = NULL) {echo ngg_geo_worldmap($options);}
	

		// function: get worldmap data
		function ngg_geo_worldmap($options = NULL)
		{
			$options['status'] = "worldmap";
			
			global $wpdb;
			
			// get database prefix
			$wpdb->ngg_gallery = $wpdb->prefix."ngg_gallery";
			$wpdb->ngg_pictures = $wpdb->prefix."ngg_pictures";
			
			// SQL: get data
			
			$picturelist = $wpdb->get_results( 
			"SELECT path, filename, title, galdesc, gid, description, meta_data, alttext, exclude
			FROM $wpdb->ngg_pictures, $wpdb->ngg_gallery
			WHERE $wpdb->ngg_pictures.pid = $wpdb->ngg_gallery.previewpic", OBJECT );
		
				foreach ($picturelist as $key => $picture) 
				{	
					// exclude?
					if ($picture->exclude == 1) {continue;}
					
					$arr_params = array ( 'nggg_id' => $picture->gid, 'nggg_title' => $picture->title );
					
					$picturelist[$key]->imageURL = site_url()."/".$picture->path."/".$picture->filename;
					$picturelist[$key]->thumbURL = site_url()."/".$picture->path."/thumbs/thumbs_".$picture->filename;
					$picturelist[$key]->imagePath = $_SERVER['DOCUMENT_ROOT']."/".$picture->path."/".$picture->filename;
					$picturelist[$key]->thumbPath = $_SERVER['DOCUMENT_ROOT']."/".$picture->path."/thumbs/thumbs_".$picture->filename;
					$picturelist[$key]->meta_data = unserialize($picture->meta_data);

				}

				return ng_gallery_geo("", $picturelist, $options);
		}

?>