<?php

/*
Plugin Name: NextGEN Gallery geo
Plugin URI: http://wordpress.org/extend/plugins/nextgen-gallery-geo/
Description: NextGEN Gallery geo is a flexibe plugin, displaying beautiful maps with your photos by using EXIF Data or geocoding.
Version: 1.0
Author: Frederic Stuhldreier
Author URI: http://www.denktfrei.de/
*/

include_once "administration.php";
include_once "functions.php";

//debug:
//error_reporting(E_ALL);
//ini_set('display_errors', 1);


function ng_gallery_geo ($out, $picturelist, $options = NULL)
{

// get options
$default_options = get_option('plugin_ngg_geo_options');
$options = wp_parse_args( $options, $default_options );

//mid must be a number
if (empty ($options['mid']) OR !is_numeric ($options['mid'])) {$options['mid'] = mt_rand(0, 999);}
if (empty ($options['status'])) {$options['status'] = 1;}


// initialising..
$map_output = "\n\n".'<!-- begin NextGEN Gallery geo -->';
$map_output .= ''."\n";
$map_output .= '<script type="text/javascript">'."\n";		
$map_output .= 'var map_'.$options['mid'].' = null;'."\n";							 
$map_output	.= 'function nggGeoMap_'.$options['mid'].'() {'."\n".'map_'.$options['mid'].' = new VEMap("ngg_geo_map_'.$options['mid'].'"); map_'.$options['mid'].'.HideDashboard();  map_'.$options['mid'].'.LoadMap(); map_'.$options['mid'].'.HideMiniMap(); map_'.$options['mid'].'.HideScalebar(); map_'.$options['mid'].'.SetMapStyle(VEMapStyle.'.$options['map'].');'."\n \n";

	// dashboard options
	if($options['dashboard'] == '1') {$map_output .= 'map_'.$options['mid'].'.ShowDashboard();';}
	if($options['minimap'] == '1') {$map_output .= 'map_'.$options['mid'].'.ShowMiniMap();';}
	if($options['scalebar'] == '1') {$map_output .= 'map_'.$options['mid'].'.ShowScalebar();';}
	//$map_output	.= 'map_'.$options['mid'].'.HideScalebar(); map_'.$options['mid'].'.ShowMiniMap();';
	
$map_output	.= 'var locs = [];'."\n";

	
	$picture_nr = 0; 			// counts pictures with geodata, $picture_nr_total couts all pictures, used for lightbox
	$picture_nr_total = 0;
	$ngg_geo_lightbox = NULL;
	
	// searching for exif-geodata
	foreach ($picturelist as $picture_data) 
		{  

		// keep lightbox in mind..
		$ngg_geo_lightbox .= ngg_geo_lightbox_data($picture_data, $options['lightbox'], $picture_nr_total);
		
			// get exif-geodata
			if ($picture_data->gps = ng_gallery_geo_coordinates($picture_data->imagePath) ) 
				{
					// get exif informations (needed for old galleries, created before ngg stored meta_data!)
					if (empty ($picture_data->meta_data)) {$picture_data = ng_gallery_geo_exif($picture_data);}
					
					// add pins
					$map_output .= ngg_geo_add_pin ($picture_data, $picture_nr, $picture_nr_total, $options); ++$picture_nr;
				} 
		
		$picture_nr_total++;	
		}
	

	if ($picture_nr == 0) // no pins -> geocoding
	{
		if ($picture_data->gps = ngg_geo_geocode($picture_data->title, $options))
		{
			// add pin
			$map_output .= ngg_geo_add_pin ($picture_data, $picture_nr, $picture_nr_total, $options); ++$picture_nr;
		
		}
		
		else {return $out;} //no data, no map, no lightbox
	}
	
	
	

	if ($picture_nr == 1) // 1 pin
	{

		// bev 
			if  ($options['bev'] == 1) {	$map_output .=	'map_'.$options['mid'].'.AttachEvent("onobliqueenter", OnObliqueEnterHandler_1); function OnObliqueEnterHandler_1() {	if (map_'.$options['mid'].'.IsBirdseyeAvailable()) {  map_'.$options['mid'].'.SetMapStyle(VEMapStyle.Birdseye); map_'.$options['mid'].'.DetachEvent("onobliqueenter", OnObliqueEnterHandler_1);	}}'."\n"; }
				
		// Fokus
		$map_output .=  'map_'.$options['mid'].'.SetCenterAndZoom(loc_0, '.$options['zoom'].');'."\n";
	}
	
	

	else // >1 Pin
	{
		//route-mode (deaktivated for worldpage)
		if ($options['route'] == 1 AND $options['status'] != "worldmap") 
		{
			//.gpx file 
			if ($gpx_data = ngg_geo_gpx($_SERVER['DOCUMENT_ROOT']."/".$picture_data->path."/data.gpx")) 
			{	
				$map_output .= $gpx_data;
				$map_output .= 'var routeColor = new VEColor('.$options['route_color'].'); var poly = new VEPolyline(12, gpxs, routeColor, '.$options['route_width'].'); map_'.$options['mid'].'.AddPolyline(poly);'."\n";
			}

			// exif gps data			
			else 
			{
			$map_output .= 'var routeColor = new VEColor('.$options['route_color'].'); var poly = new VEPolyline(12, locs, routeColor, '.$options['route_width'].'); map_'.$options['mid'].'.AddPolyline(poly);'."\n";
			}
		}

		// focus on gpx
		if 		(!empty($gpx_data)) 	{$map_output .= 'map_'.$options['mid'].'.SetMapView(gpxs);'."\n";}
		
		// focus on pictures
		else						{$map_output .= 'map_'.$options['mid'].'.SetMapView(locs);'."\n";}

	}


$map_output	.= '}'."\n".'</script>'."\n";

// show div box & start map
$map_output .= '<div style="width: '.$options["map_width"].'; height: '.$options["map_height"].';" id="ngg_geo_map_'.$options['mid'].'" class="ngg_geo_map"></div>'; 

// ajax: don't start map
if ($options['status'] != 'ajax') {$map_output .= ' <script> jQuery(document).ready(function ($) {nggGeoMap_'.$options['mid'].'();});</script>';}

// add lightbox effect
$map_output	.= "\n\n".'<script>'."\n".'function ngg_geo_lightbox_'.$options['mid'].'(indexNr) {'."\n";

	// fancybox
	if ($options['lightbox'] == "Fancybox")
	{
		$map_output	.= 'jQuery.fancybox.open([ '.$ngg_geo_lightbox.' ], {padding : 0, index : indexNr});';
	}

	// slimbox
	if ($options['lightbox'] == "Slimbox")
	{
		$map_output	.= 'jQuery.slimbox(['."\n".$ngg_geo_lightbox.'], indexNr);';
	}

$map_output	.= "\n".'} '."\n".'</script>'."\n";

$map_output .= "\n".'<!-- end NextGEN Gallery geo -->'."\n\n";

// show map
$out = $out.$map_output;
return $out;
}

?>